]> git.phdru.name Git - dotfiles.git/blob - .shellrc
lib/config/gpg-agent-update-tty: Change gpg-connect-agent command line
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             for _compf in /etc/bash_completion.d/*; do
80                . $_compf
81             done
82          fi
83       elif [ "$SHELL" = /usr/local/bin/bash ]; then
84          if [ -d /usr/local/etc/bash_completion.d ]; then
85             for _compf in /usr/local/etc/bash_completion.d/*; do
86                . $_compf
87             done
88          fi
89       else
90          echo "Unknown OS type, cannot source bash_completion" >&2
91       fi
92    fi
93
94    has_completion() { return 0; }
95    if [ "$SHELL" = /bin/bash ]; then
96       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
97          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
98       fi
99    elif [ "$SHELL" = /usr/local/bin/bash ]; then
100       if [ -d /usr/local/etc/bash_completion.d ]; then
101          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
102       fi
103    fi
104
105    for cmd in builtin cgmem_nice command dbus-launch exec \
106       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
107       time whence whereis which xargs; do
108          ! has_completion $cmd && complete -o default -A command $cmd
109    done
110
111    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
112       telnet t tt \
113       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
114       whois wget wget-m wget-wrapper ww; do
115          ! has_completion $cmd && complete -A hostname $cmd
116    done
117
118    for cmd in distribute ftp lftp r rsync \
119       s scp ssh smbclient tcpdump tshark wireshark; do
120          ! has_completion $cmd && complete -o default -A hostname $cmd;
121    done
122
123    delegate_completion() {
124       local prog programs
125       prog=$1
126       if has_completion $prog; then
127          shift
128          programs="$@"
129          eval "_${prog}_completion_loader() {
130             _completion_loader $prog
131             complete -F _$prog $programs
132             unset _${prog}_completion_loader
133             return 124
134          }"
135          complete -F _${prog}_completion_loader $programs
136       fi
137    }
138
139    delegate_completion make m
140    delegate_completion ping p
141    delegate_completion rsync r
142    delegate_completion ssh s
143    delegate_completion wget wget-m wget-wrapper ww
144
145    unset has_completion delegate_completion
146
147    complete -A job bg fg j jobs wait
148    complete -A variable -A function unset
149
150    if [ -d "$HOME/lib/config" ]; then
151       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
152    fi
153    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
154
155    #if type -p pip >/dev/null 2>&1; then
156    #   eval "`pip completion --bash`"
157    #   rm -rf /tmp/pip_build_"$USER"
158    #fi
159
160    #if which pyenv >/dev/null 2>&1; then
161    #   eval "`pyenv init -`"
162    #   eval "`pyenv virtualenv-init -`"
163    #fi
164
165    source virtualenvwrapper_lazy.sh 2>/dev/null
166
167    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
168       . "$VIRTUAL_ENV/bin/activate"
169    fi
170
171 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
172    back() { cd - "$@"; }
173    j() { jobs; }
174 fi
175
176
177 # clear screen and history, logout
178 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
179
180
181 if test -x /usr/bin/git >/dev/null 2>&1; then
182    # chdir to a directory
183    cdgitpath() {
184       if [ -z "$1" -o -n "$2" ]; then
185          echo "Usage: cdgitpath path_key" >&2
186          return 1
187       else
188          path_key="$1"
189       fi
190
191       if [ -z "$path_key" ]; then
192          echo "Usage: cdgitpath path_key" >&2
193          return 1
194       fi
195
196       cd "`git config --get --path $path_key`"
197    }
198
199    # chdir to a remote's directory (if the remote is on the local FS)
200    cdremote() {
201       if [ -z "$1" ]; then
202          branch="`git rev-parse --abbrev-ref HEAD`"
203          remote="`git config --get branch.$branch.remote`"
204       elif [ -n "$2" ]; then
205          echo "Usage: cdremote [remote_name]" >&2
206          return 1
207       else
208          remote="$1"
209       fi
210
211       if [ -z "$remote" ]; then
212          echo "Cannot find remote for branch $branch" >&2
213          echo "Usage: cdremote [remote_name]" >&2
214          return 1
215       fi
216
217       cdgitpath remote.$remote.url
218    }
219
220    if test -n "$BASH_VERSION"; then
221       # completion for aliases in global .gitconfig
222
223       # fixup rbi rbia rbiap rbip - do refs name completion
224       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
225       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
226       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
227       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
228       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
229       #
230       # push-to-all-remotes - do branch name completion
231       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
232
233       _cdgitpath_completion_loader() {
234          _completion_loader git
235          complete -F _cdgitpath_complete cdgitpath git-open
236          unset _cdgitpath_completion_loader
237          return 124
238       }
239
240       _cdgitpath_complete() {
241          local cword="${COMP_CWORD}" cur="${COMP_WORDS[COMP_CWORD]}";
242          COMPREPLY=(`compgen -W "$(__git_config_get_set_variables)" -- "$cur"`)
243       }
244
245       _git_open() {
246          _cdgitpath_complete
247       }
248
249       complete -F _cdgitpath_completion_loader cdgitpath git-open
250
251       # list remotes with URLs matching a regexp
252       _list_remotes() {
253          if [ -z "$1" -o -n "$2" ]; then
254             echo "Usage: _list_remotes remote_regexp" >&2
255             return 1
256          fi
257          GIT_REMOTES=""
258          local remote
259          for remote in `git remote`; do
260             if git config --get remote.$remote.url | grep -q "$1"; then
261                GIT_REMOTES="$GIT_REMOTES $remote"
262             fi
263          done
264       }
265
266       # completion for cdremote and git-open-remote - list remotes with a pattern
267       _list_remotes_completion() {
268          local cur="${COMP_WORDS[COMP_CWORD]}";
269          _list_remotes "$1"
270          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
271          unset GIT_REMOTES
272       }
273
274       # completion for cdremote - list remotes with directories as URLs
275       _cdremote_complete() {
276          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
277          if [ ${#COMPREPLY[*]} -eq 0 ]; then
278             _list_remotes_completion .
279          fi
280       }
281
282       complete -F _cdremote_complete cdremote
283
284       # completion for git-open-remote - list remotes with http(s) URLs
285       _git_open_remote() {
286          _list_remotes_completion '^http\(s\)\?://'
287          if [ ${#COMPREPLY[*]} -eq 0 ]; then
288             _list_remotes_completion .
289          fi
290       }
291
292       complete -F _git_open_remote git-open-remote
293    fi
294 fi
295
296
297 include() {
298    cfg="$1"
299    if [ -f "./$cfg" -a -r "./$cfg" ]; then
300       echo "Reading config file \`$cfg'" 1>&2
301       . "./$cfg"
302    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
303       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
304       . "$HOME/lib/config/$cfg"
305    else
306       echo "Cannot find config file \`$cfg'" 1>&2
307    fi
308 }
309
310
311 mc() {
312    if test -n "$BASH_VERSION"; then
313       MC_SAVE_OPS1="$OPS1"
314       OPS1="\u@\h "
315    fi
316
317    if [ -n "$SLOWTERM" ]; then
318       MC_SLOW="--slow"
319    fi
320
321    case "$TERM" in
322       screen*) # screen, screen.rxvt
323          if [ "$TERM" = screen.rxvt ]; then
324             MC_SAVE_TERM="$TERM"
325             TERM=rxvt
326          fi
327          MC_XTERM="-x"
328       ;;
329    esac
330
331    #TMPDIR="$HOME"/tmp
332    #export TMPDIR
333
334    MC_FOUND=NO
335
336    for wrapper in \
337          /usr/local/share/mc/bin/mc-wrapper.sh \
338          /usr/local/libexec/mc/mc-wrapper.sh \
339          /usr/share/mc/bin/mc-wrapper.sh; do
340       if [ -r $wrapper ]; then
341          . $wrapper $MC_SLOW $MC_XTERM "$@"
342          rc=$?
343          MC_FOUND=YES
344          break
345       fi
346    done
347
348    if [ $MC_FOUND = NO ]; then
349       for mc in /usr/local/bin/mc /usr/bin/mc; do
350          if [ -x $mc ]; then
351             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
352             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
353                MC_TMP_DIR="${TMPDIR-/tmp}"
354             fi
355             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
356             mc_type="`mc_type.py $mc`"
357             if [ "$mc_type" = old ]; then
358                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
359             elif [ "$mc_type" = new ]; then
360                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
361             else
362                continue
363             fi
364             rc=$?
365             MC_FOUND=YES
366             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
367             break
368          fi
369       done
370    fi
371
372    if [ $MC_FOUND = NO ]; then
373       echo "Cannot find mc-wrapper.sh or mc" >&2
374       rc=1
375    fi
376
377    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
378    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
379    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
380          MC_SLOW MC_TMP_DIR MC_XTERM
381
382    return $rc
383 }
384
385
386 mkcd() {
387    if [ $# -ne 1 ]; then
388       echo "Usage: mkcd directory_name" >&2
389    elif [ -d "$1" ]; then
390       cd "$1"
391    elif [ -e "$1" ]; then
392       echo "Error: $1 is a file" >&2
393    else
394       mkdir -p "$1" && cd "$1"
395    fi
396 }
397
398
399 if which tmux >/dev/null 2>&1; then
400    tmux() {
401       case "$TERM" in
402          rxvt)
403             TERM=rxvt-unicode command tmux "$@"
404          ;;
405
406          *)
407             command tmux "$@"
408          ;;
409       esac
410    }
411 fi
412
413
414 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
415    X() { startx >> .Xserver.log 2>&1; cyr; }
416 fi
417
418 x() { exit; }